/*Квартирный звонок на базе DFPlayer Mini + IR ON/OFF
 * http://infotex58.ru
 * Задержки по 10мс необходимы перед коммандами на плеер!!! Не трогать иначе будет "глючить"
 */
#include <SoftwareSerial.h>
#include <DFPlayer_Mini_Mp3.h>
#include <IRremote.h>

SoftwareSerial mySerial(10, 11); // RX, TX DF Плеера
int vol = 15;                 // Громкость
int RECV_PIN = 2;             //Пин для подключения IR датчика D2
int on = 0;
unsigned long last = millis();
IRrecv irrecv(RECV_PIN);
decode_results results;

void setup () {
  mySerial.begin (9600);
  irrecv.enableIRIn();
  pinMode(13, OUTPUT);
  mp3_set_serial (mySerial);      //Работаем с "Софтовым" портом
  //delay (10);
  //mp3_reset ();               //Ресет модуля
  delay (10);
  mp3_set_EQ (3);                 // Эквалайзер
}

void loop () {
  boolean play_state = digitalRead(3);// Кнопка на прерывании D3
  ir();
  if (play_state == LOW) {
    delay (10);
    mp3_next ();
    delay(20000);         // Время звучания
    for (int i = vol; i >= 1; i--) {  // Эффект FADE
      mp3_set_volume (i);
      delay (100);
    }
  }
  delay (10);
  mp3_stop ();
  delay (10);
  mp3_set_volume (vol);
}

void ir () {
  if (irrecv.decode(&results)) {
    if (millis() - last > 250) {
      on = !on;
      digitalWrite(13, on ? HIGH : LOW);
      vol = (vol, on ? 15 : 0);
    }
    last = millis();
    irrecv.resume();
  }
}


